package com.qgs.dc.influx.controller;


import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.parser.JSONToken;
import com.influxdb.client.WriteApi;
import com.influxdb.client.domain.WritePrecision;
import com.influxdb.client.write.Point;
import com.influxdb.query.FluxRecord;
import com.influxdb.query.FluxTable;
import com.qgs.dc.influx.common.DataUtils;
import com.qgs.dc.influx.config.InfluxClient;
import com.qgs.dc.influx.param.*;
import com.qgs.dc.influx.template.Event;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.time.Instant;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Random;

@RestController
@RequestMapping("/influx")
public class InfluxController {
    private static final Logger logger = LoggerFactory.getLogger(InfluxController.class);


//
//
//    @PostMapping("/insertBatch")
//    public void insertBatch() throws InterruptedException {
//        List<Event> list = new ArrayList<>();
//        Random r = new Random();
//
//        for(int i=0;i<999;i++){
//            Thread.sleep(10);
//            Event event = new Event();
//            event.setTime(Instant.now());
//            event.setTransationId("asas"+i);
//            event.setArgName("LTWeight");
//            Double d = r.nextDouble() * 2.5  + 66;
//            event.setArgValue(d);
//
//            list.add(event);
//        }
//        InfluxClient.Client.batchInsert(list,"Weight");
//    }
//
//    @PostMapping("/forTestInsertBatch")
//    public void forTestInsertBatch() throws InterruptedException {
//        List<Event> list = new ArrayList<>();
//        Random r = new Random();
//        for(int i=0;i<99;i++){
//            Thread.sleep(10);
//            Event event = new Event();
//            event.setTime(Instant.now());
//            event.setTransationId("forbatch"+i);
//            event.setArgName("LTWeight");
//            Double d = r.nextDouble() * 2.5  + 66;
//            event.setArgValue(d);
//            event.setBatchNum(4);
//            event.setInspectionSheetId(i+"");
//            list.add(event);
//        }
//        InfluxClient.Client.batchInsert(list,"Weight");
//    }
//
//
//
//
//    @PostMapping("/insertBatchJYD")
//    public void insertBatchJYD() throws InterruptedException {
//        List<Event> list = new ArrayList<>();
//        Random r = new Random();
//        Instant instant = DataUtils.getBeforeDate(400).toInstant();
//
//        for(int j=0;j<10;j++){
//            for(int i=0;i<99;i++){
//                Thread.sleep(10);
//                Event event = new Event();
//                event.setTime(instant);
//                event.setTransationId("asas"+i);
//                event.setArgName("LTWeight");
//                Double d = r.nextDouble() * 2.5  + 66;
//                event.setInspectionSheetId(j+"");
//                event.setArgValue(d);
//                event.setBatchNum(i);
//                list.add(event);
//            }
//        }
//        InfluxClient.Client.batchInsert(list,"WeightHei");
//    }
//
//
//
//    @PostMapping("/insertBatchJYDForTest")
//    public void insertBatchJYDForTest() throws InterruptedException {
//        List<Event> list = new ArrayList<>();
//        Random r = new Random();
//
//        for(int i=0;i<999;i++){
//            Thread.sleep(10);
//            Event event = new Event();
//            event.setTime(DataUtils.getAfterDate(i).toInstant());
//            event.setTransationId("asas"+i);
//            event.setArgName("LostDays");
//            int i1 = r.nextInt(10);
////            if(i1<4){
////                event.setArgValue(new Double(0));
////            }else {
////                event.setArgValue(new Double(1));
////            }
//            event.setInspectionSheetId(i+"");
//
//            event.setBatchNum(i);
//            list.add(event);
//        }
//        InfluxClient.Client.batchInsert(list,"WeightHeiHei");
//    }

    /**
     * 测试连接是否正常
     *
     * @return
     *      true    服务正常健康
     *      false   异常
     */
    @PostMapping("/ping")
    public void ping() throws InterruptedException {
        boolean ping = InfluxClient.Client.ping();
        System.out.println(ping);
    }

    @PostMapping("/query")
    public List<FluxTable> query() throws InterruptedException {
        List<Event> list = new ArrayList<>();

        QueryDataParam queryDataParam = new QueryDataParam();
        queryDataParam.setBucket("qgs-bucket");
        queryDataParam.setMeasurement("ASProcessCompleteEventAS");
        List<String> dropNames = new ArrayList<>();
        dropNames.add("transationId");
        dropNames.add("inspectionSheetId");
        queryDataParam.setDropedTagNames(dropNames);
        queryDataParam.setTag(new Tag("argName","arg6"));
        queryDataParam.setRange(new Range(DataUtils.getBeforeDate(10).toInstant(),Instant.now()));
        queryDataParam.setPageInfo(new PageInfo(1,10));
        List<FluxTable> query = InfluxClient.Client.query(queryDataParam);


        for (FluxTable fluxTable : query) {
            List<FluxRecord> records = fluxTable.getRecords();
            for (FluxRecord fluxRecord : records) {
                System.out.println("value: " + fluxRecord.getValueByKey("_value"));
            }
        }
        System.out.println();

        return query;
    }

    public static void main(String[] args) {
        List<Event> list = new ArrayList<>();

        QueryDataParam queryDataParam = new QueryDataParam();
        queryDataParam.setBucket("qgs-bucket");
        queryDataParam.setMeasurement("ASProcessCompleteEventAS");
        List<String> dropNames = new ArrayList<>();
        dropNames.add("transationId");
        dropNames.add("inspectionSheetId");
        queryDataParam.setDropedTagNames(dropNames);
        queryDataParam.setTag(new Tag("argName","arg7"));
        queryDataParam.setRange(new Range(DataUtils.getBeforeDate(10).toInstant(),Instant.now()));
        queryDataParam.setPageInfo(new PageInfo(2,10));
        List<FluxTable> query = InfluxClient.Client.query(queryDataParam);


        for (FluxTable fluxTable : query) {
            List<FluxRecord> records = fluxTable.getRecords();
            for (FluxRecord fluxRecord : records) {
                System.out.println("value: " + fluxRecord.getValueByKey("_value"));
            }
        }
    }


    public Point insert(Event event, String measurement){
        Point point = Point.measurement(measurement)
                .addTag("transationId", event.getTransationId())
                .addTag("argName", event.getArgName())
                .addField("argValue", event.getArgValue())
                .time(event.getTime().toEpochMilli(), WritePrecision.MS);
        return point;
    }

    @PostMapping("/insert")
    public void insert() throws InterruptedException {
        Event event = new Event();
        event.setTime(Instant.now());
        event.setTransationId("asasd11");
        event.setArgName("argName11");
        event.setArgValue("900001");
        Point asProcessCompleteEvent = insert(event, "ASProcessCompleteEvent");
        InfluxClient.Client.insert(event,"ASProcessCompleteEvent");
    }

    @PostMapping("/insertEvents")
    public void insertEvents(@RequestBody InsertParam insertParam) throws InterruptedException{
        InfluxClient.Client.batchInsert(insertParam.getList(),insertParam.getMeasurement());
    }

    @PostMapping("/queryEvents")
    public JSONArray queryEvents(@RequestBody QueryDataParam queryDataParam) throws InterruptedException{
        List<FluxTable> fluxTables = InfluxClient.Client.query(queryDataParam);
        List<FluxRecord> fluxRecords = new ArrayList<>();
        for (FluxTable fluxTable:fluxTables){
            fluxRecords.addAll(fluxTable.getRecords());
        }
        JSONArray jsonArray = new JSONArray();
        for (FluxRecord fluxRecord:fluxRecords) {
            Map<String,Object> map = fluxRecord.getValues();
            System.out.println(map);
            JSONObject jsonObject = new JSONObject();
            jsonObject.put(map.get("argName").toString(),map.get("_value").toString());
            if (map.get("transationId")!=null){
                jsonObject.put("transationId",map.get("transationId").toString());
            }
            jsonObject.put("measurement",map.get("_measurement").toString());
            jsonObject.put("time",map.get("_time").toString());
            jsonArray.add(jsonObject);
        }
        System.out.println(jsonArray);
        return jsonArray;
    }
}
